--[[

Interface: 1.4.4.0 1.4.4RC8

Author: GtX 
Date: 14.04.2017
Version: 1.1

https://www.gtxmods.com/contact-us/ 

Credits:
ventTrailer.lua by GtX @ GTX MODS

History:
V 1.0 @ 14.04.2017 - Initial Release by GtX @ GTX MODS
V 1.1 @ 04.07.2017 - Set Totation Nodes to shut off when trailer is detached by GtX

Free to use and edit but please keep credits and update Version Number and descriptions. If edited, send us a copy we would love to see it > https://www.gtxmods.com/contact-us/ 

Designed to be used on the CRT Animal Trailers. Allows use of turnedOnRotationNodes with trailers. Rotation Node activated when filling started and stops when empty. 

EXAMPLE FOR XML:
<turnedOnRotationNodes>
		<turnedOnRotationNode index="0>1" type="ventTrailer" rotSpeed="-900"  rotAxis="1" turnOnFadeTime="2" turnOffFadeTime="4" />
</turnedOnRotationNodes>

]]

trailerVent = {};

function trailerVent.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

function trailerVent:load(savegame)

	self.isFilled = trailerVent.isFilled
	self.isUsedOn = trailerVent.isUsedOn
	
	if self.isClient then
	    self.venttrailerTurnedOnRotationNodes = Utils.loadRotationNodes(self.xmlFile, {}, "vehicle.turnedOnRotationNodes.turnedOnRotationNode", "ventTrailer", self.components);
	end;
end;

function trailerVent:delete()
end;

function trailerVent:mouseEvent(posX, posY, isDown, isUp, button)
end;

function trailerVent:keyEvent(unicode, sym, modifier, isDown)
end;


function trailerVent:update(dt)
	if self.isClient then
	local runFans = self:isFilled() and self:isUsedOn()
		Utils.updateRotationNodes(self, self.venttrailerTurnedOnRotationNodes, dt, runFans);
	end;
end;

function trailerVent:isFilled()
		if self.getFillLevel ~= nil then
			return self:getFillLevel() > 0
		end;
	return false
end;

function trailerVent:isUsedOn()
	local rootAttacherVehicle = self:getRootAttacherVehicle()
	if rootAttacherVehicle ~= nil and rootAttacherVehicle.motor ~= nil then
		return true
	end;
	return false
end;

function trailerVent:updateTick(dt)
end;

function trailerVent:draw()    
end;